var check = require('./check');
var loadSupplierModule = require('./loadSupplierModule');
var async = require('async');
module.exports = function(data, callback) {
  var getSupplier = data.getSupplier || require('./getSupplier')
  if (!callback) {
    callback = data;
    return callback('no data parameter supplier');
  }
  var supplier, lib;
  var supplierCode = data.supplierCode;
  async.series([
    function(cb) {
      check(data, cb);
    },
    function(cb) {
      loadSupplierModule(supplierCode, function (err, reply) {
        if (err) { return cb(err); }
        if (!reply) {
          return cb('supplier module not found');
        }
        lib = reply;
        cb();
      });
    },
    function(cb) {
      getSupplier(data, function (err, reply) {
        if (err) { return cb(err) }
        data.payload.supplierID = reply._id
        cb()
      })
    }
  ], function (err) {
    if (err) { return callback(err); }
    callback(null, lib.scraperProcessData);
  });
};
